diff -Nru epiphany-browser-3.4.2/debian/changelog epiphany-browser-3.4.2/debian/changelog
--- epiphany-browser-3.4.2/debian/changelog	2012-09-22 14:18:13.000000000 +0100
+++ epiphany-browser-3.4.2/debian/changelog	2013-01-26 17:38:37.000000000 +0000
@@ -1,3 +1,11 @@
+epiphany-browser (3.4.2-2.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Apply patch from Stephan Schreiber to fix a race condition starting the
+    history service thread (closes: #697173).
+
+ -- Julien Cristau <jcristau@debian.org>  Sat, 26 Jan 2013 17:38:36 +0000
+
 epiphany-browser (3.4.2-2) unstable; urgency=low
 
   * Rename epiphany.desktop to epiphany-browser.desktop so that the 
diff -Nru epiphany-browser-3.4.2/debian/control epiphany-browser-3.4.2/debian/control
--- epiphany-browser-3.4.2/debian/control	2012-09-22 14:21:48.000000000 +0100
+++ epiphany-browser-3.4.2/debian/control	2013-01-26 17:50:08.000000000 +0000
@@ -7,7 +7,7 @@
 Section: gnome
 Priority: optional
 Maintainer: Josselin Mouette <joss@debian.org>
-Uploaders: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>, Gustavo Noronha Silva <kov@debian.org>, Michael Biebl <biebl@debian.org>, Sebastian DrÃ¶ge <slomo@debian.org>
+Uploaders: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>, Michael Biebl <biebl@debian.org>, Sebastian DrÃ¶ge <slomo@debian.org>
 Build-Depends: debhelper (>= 8),
                cdbs (>= 0.4.90),
                dh-autoreconf,
diff -Nru epiphany-browser-3.4.2/debian/patches/history-thread-startup-race.patch epiphany-browser-3.4.2/debian/patches/history-thread-startup-race.patch
--- epiphany-browser-3.4.2/debian/patches/history-thread-startup-race.patch	1970-01-01 01:00:00.000000000 +0100
+++ epiphany-browser-3.4.2/debian/patches/history-thread-startup-race.patch	2013-01-26 17:37:34.000000000 +0000
@@ -0,0 +1,46 @@
+diff -pr -u8 epiphany-browser-orig/lib/history/ephy-history-service.c epiphany-browser-3.4.2/lib/history/ephy-history-service.c
+--- epiphany-browser-orig/lib/history/ephy-history-service.c	2012-12-27 15:42:56.478406326 +0100
++++ epiphany-browser-3.4.2/lib/history/ephy-history-service.c	2012-12-27 15:44:06.958409578 +0100
+@@ -183,18 +183,19 @@ ephy_history_service_class_init (EphyHis
+   g_type_class_add_private (gobject_class, sizeof (EphyHistoryServicePrivate));
+ }
+ 
+ static void
+ ephy_history_service_init (EphyHistoryService *self)
+ {
+   self->priv = EPHY_HISTORY_SERVICE_GET_PRIVATE (self);
+ 
+-  self->priv->history_thread = g_thread_new ("EphyHistoryService", (GThreadFunc) run_history_service_thread, self);
++  self->priv->history_thread = NULL;
+   self->priv->queue = g_async_queue_new ();
++  g_thread_new ("EphyHistoryService", (GThreadFunc) run_history_service_thread, self);
+ }
+ 
+ EphyHistoryService *
+ ephy_history_service_new (const char *history_filename)
+ {
+   return EPHY_HISTORY_SERVICE (g_object_new (EPHY_TYPE_HISTORY_SERVICE,
+                                              "history-filename", history_filename,
+                                               NULL));
+@@ -355,17 +356,17 @@ ephy_history_service_execute_quit (EphyH
+ }
+ 
+ static gpointer
+ run_history_service_thread (EphyHistoryService *self)
+ {
+   EphyHistoryServicePrivate *priv = self->priv;
+   EphyHistoryServiceMessage *message;
+ 
+-  g_assert (priv->history_thread == g_thread_self ());
++  priv->history_thread = g_thread_self ();
+ 
+   if (ephy_history_service_open_database_connections (self) == FALSE)
+     return NULL;
+ 
+   do {
+     message = g_async_queue_try_pop (priv->queue);
+     if (!message) {
+       /* Schedule commit if needed. */
+
+
+Signed-off-by: Stephan Schreiber <info@fs-driver.org>
diff -Nru epiphany-browser-3.4.2/debian/patches/series epiphany-browser-3.4.2/debian/patches/series
--- epiphany-browser-3.4.2/debian/patches/series	2012-05-23 06:21:58.000000000 +0100
+++ epiphany-browser-3.4.2/debian/patches/series	2013-01-26 17:37:44.000000000 +0000
@@ -2,3 +2,4 @@
 07_bookmarks.patch
 12_safetypes.patch
 14_pkglibdir.patch
+history-thread-startup-race.patch
